package transferpipes;

import net.minecraftforge.common.ForgeDirection;
import buildcraft.core.DefaultProps;
import buildcraft.transport.pipes.PipeItemsWood;

public class PipeItemsRedstoneWood extends PipeItemsWood {

	public PipeItemsRedstoneWood(int itemID) {
		super(itemID);
		// TODO 自動生成されたコンストラクター・スタブ
	}
	public int baseTexture = 2 * 16 + 0;
	public int plainTexture = 2 * 16 + 1;
	
	@Override
	public String getTextureFile() {
		return "/sprite/telepipes.png";
	}
	
	@Override
	public int getTextureIndex(ForgeDirection direction) {
		if (direction == ForgeDirection.UNKNOWN)
			return baseTexture;
		else {
			int metadata = worldObj.getBlockMetadata(xCoord, yCoord, zCoord);

			if (metadata == direction.ordinal())
				return plainTexture;
			else
				return baseTexture;
		}
	}

	boolean lastPower = false;

	public void updateEntity() {
		super.updateEntity();
		boolean currentPower = worldObj.isBlockIndirectlyGettingPowered(xCoord, yCoord, zCoord);

		if (currentPower != lastPower) {
			if(currentPower)
				getPowerProvider().receiveEnergy(1f, ForgeDirection.UP);
			lastPower = currentPower;
		}
	}
};
