package transferpipes;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.server.MinecraftServer;
import net.minecraft.entity.player.*;
import net.minecraft.item.*;
import net.minecraft.world.*;
import net.minecraft.tileentity.*;
import net.minecraftforge.common.ForgeDirection;
import buildcraft.api.tools.IToolWrench;
import buildcraft.transport.BlockGenericPipe;
import buildcraft.transport.Pipe;
import buildcraft.transport.PipeTransport;
import buildcraft.transport.TileGenericPipe;
import buildcraft.transport.pipes.PipeLogic;

public abstract class PipeTransfer extends Pipe {
	
	public boolean remoteMode = false;
	protected boolean dimpipe = false;
	public boolean signalBuffer[] = {false, false, false, false};
	protected int toPosX = 0,toPosY = 0,toPosZ = 0,toDim = 0;
	public PipeTransfer(PipeTransport transport, PipeLogic logic, int itemID) {
		super(transport, logic, itemID);
	}
	
	@Override
	public boolean blockActivated(World world, int i, int j, int k, EntityPlayer entityplayer){
		ItemStack is = entityplayer.getCurrentEquippedItem();
		if(is == null)
			return false;
		Item item = is.getItem();
		if (item instanceof IToolWrench) {
			if(item instanceof ItemRemoteConnector)
				return false;
			
			TileGenericPipe tile = getTile(getWorldForDimension(toDim), toPosX, toPosY, toPosZ);
			PipeTransfer pipe = null;
			if(tile != null)
				pipe = getPipe(tile);
			if(pipe != null && remoteMode){
				boolean buf[] = new boolean[]{false, false, false, false};
				broadcastSignal = buf;
				pipe.broadcastSignal = buf;
				signalBuffer = buf;
				pipe.signalBuffer = buf;
				entityplayer.addChatMessage("Initialize Signal State");
				container.scheduleNeighborChange();
				tile.scheduleNeighborChange();
			}
			return true;
		}
		return false;
	}
	
	@Override
	public void readFromNBT(NBTTagCompound nbt)
	{
		super.readFromNBT(nbt);
		toPosX = nbt.getInteger("X");
		toPosY = nbt.getInteger("Y");
		toPosZ = nbt.getInteger("Z");
		remoteMode = nbt.getBoolean("remoteMode");
		toDim = nbt.getInteger("dim");
	}
	
	@Override
	public void writeToNBT(NBTTagCompound nbt)
	{
		super.writeToNBT(nbt);
		nbt.setInteger("X", toPosX);
		nbt.setInteger("Y", toPosY);
		nbt.setInteger("Z", toPosZ);
		nbt.setBoolean("remoteMode", remoteMode);
		nbt.setInteger("dim", toDim);
	}
	
	protected void teleportSignal(){
		TileGenericPipe tile = getTile(getWorldForDimension(toDim), toPosX, toPosY, toPosZ);
		PipeTransfer pipe = null;
		if(tile !=null)
			pipe = getPipe(tile);
		if(pipe != null){
			for(int i = 0;i <= 3;i++){
				if(signalStrength[i] != 0 && !signalBuffer[i]){
					pipe.broadcastSignal[i] = true;
					if(!pipe.signalBuffer[i]){
						tile.scheduleNeighborChange();
						System.out.println("b");
					}
					pipe.signalBuffer[i] = true;
					tile.scheduleNeighborChange();
				}
				if(signalStrength[i] == 0 && !signalBuffer[i]){
					pipe.broadcastSignal[i] = false;
					if(pipe.signalBuffer[i]){
						tile.scheduleNeighborChange();
						System.out.println("b");
					}
					pipe.signalBuffer[i] = false;
				}
			}
		}
	}
	
	@Override
	public void onBlockRemoval()
	{
		super.onBlockRemoval();
		PipeTransfer pipe = null;
		TileGenericPipe tile = getTile(getWorldForDimension(toDim), toPosX, toPosY, toPosZ);
		if(tile !=null)
			pipe = getPipe(tile);
		if(pipe != null){
			if((xCoord == pipe.toPosX) && (yCoord == pipe.toPosY) && (zCoord == pipe.toPosZ)){
				pipe.remoteMode = false;
				tile.scheduleRenderUpdate();
			}
		}
	}
	
	//パイプのインスタンス取得
	public TileGenericPipe getTile(World world, int x,int y,int z)
	{
		TileEntity tile = world.getBlockTileEntity(x, y, z);
		if(tile instanceof TileGenericPipe)
			return (TileGenericPipe)tile;
		return null;
	}
	
	public PipeTransfer getPipe(TileGenericPipe tile){
		if(tile.pipe instanceof PipeTransfer)
			return (PipeTransfer)tile.pipe;
		return null;
	}
	
	public World getWorldForDimension(int dim)
	{
		MinecraftServer server = MinecraftServer.getServer();
		return server.worldServerForDimension(dim);
	}
}
