package transferpipes;

import java.io.File;


import buildcraft.core.DefaultProps;
import buildcraft.core.utils.Localization;
import buildcraft.transport.BlockGenericPipe;
import buildcraft.transport.ItemPipe;
import buildcraft.transport.Pipe;
import buildcraft.transport.TransportProxyClient;
import buildcraft.transport.render.PipeItemRenderer;
import buildcraft.BuildCraftCore;
import buildcraft.BuildCraftEnergy;
import buildcraft.BuildCraftSilicon;
import buildcraft.BuildCraftTransport;
import net.minecraft.src.*;
import net.minecraft.item.*;
import net.minecraft.block.Block;
import net.minecraft.creativetab.*;
import net.minecraftforge.client.MinecraftForgeClient;
import net.minecraftforge.common.Configuration;
import net.minecraftforge.common.Property;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid="transferpipes", name="TransferPipes", version="1.1")
@NetworkMod(clientSideRequired=true, serverSideRequired=true)
public class TransferPipes{
	@Instance("TransferPipes")
	public final static PipeItemRenderer pipeItemRenderer = new PipeItemRenderer();
	public static TransferPipes instance = new TransferPipes();
	public static Item pipeItemsTransfer;
	public static int pipeItemsTransferId;
	public static Item pipeLiquidsTransfer;
	public static int pipeLiquidsTransferId;
	public static Item pipePowerTransfer;
	public static int pipePowerTransferId;
	public static Item pipeItemsDimTransfer;
	public static int pipeItemsDimTransferId;
	public static Item pipeLiquidsDimTransfer;
	public static int pipeLiquidsDimTransferId;
	public static Item pipePowerDimTransfer;
	public static int pipePowerDimTransferId;
	public static Item pipeItemsRedstoneWood;
	public static int pipeItemsRedstoneWoodId;
	public static Item remoteConnector;
	public static int remoteConnectorId;
	
	public static boolean balanceMode;
	@PreInit
	public void loadConfiguration(FMLPreInitializationEvent evt){
		instance = this;
		Configuration cfg = new Configuration(evt.getSuggestedConfigurationFile());
		cfg.load();
		Property prop;
		prop = cfg.get("pipeItemsTransfer.id", Configuration.CATEGORY_ITEM, 4196);
		pipeItemsTransferId = prop.getInt();
		prop = cfg.get("pipeLiquidsTransfer.id", Configuration.CATEGORY_ITEM, 4197);
		pipeLiquidsTransferId = prop.getInt();
		prop = cfg.get("pipePowerTransfer.id", Configuration.CATEGORY_ITEM, 4198);
		pipePowerTransferId = prop.getInt();
		prop = cfg.get("remoteConnector.id", Configuration.CATEGORY_ITEM, 4199);
		remoteConnectorId = prop.getInt();
		prop = cfg.get("pipeItemsRedstoneWood.id", Configuration.CATEGORY_ITEM, 4200);
		pipeItemsRedstoneWoodId = prop.getInt();
		prop = cfg.get("pipeItemsDimTransfer.id", Configuration.CATEGORY_ITEM, 4201);
		pipeItemsDimTransferId = prop.getInt();
		prop = cfg.get("pipeLiquidsDimTransfer.id", Configuration.CATEGORY_ITEM, 4202);
		pipeLiquidsDimTransferId = prop.getInt();
		prop = cfg.get("pipePowerDimTransfer.id", Configuration.CATEGORY_ITEM, 4203);
		pipePowerDimTransferId = prop.getInt();
		prop = cfg.get("BalanceRecipe", Configuration.CATEGORY_GENERAL, false);
		balanceMode = prop.getBoolean(true);
		cfg.save();
	}
	@Init
	public void initialize(FMLInitializationEvent evt)
	{
		System.out.println("Transfer Pipes Loaded");
		MinecraftForgeClient.preloadTexture("/sprite/telepipes.png");
		pipeItemsTransfer = registerPipe(pipeItemsTransferId, PipeItemsTransfer.class, "Transfer Transport Pipe");
		pipeLiquidsTransfer = registerPipe(pipeLiquidsTransferId, PipeLiquidsTransfer.class, "Transfer Waterproof Pipe");
		pipePowerTransfer = registerPipe(pipePowerTransferId, PipePowerTransfer.class, "Transfer Conductive Pipe");
		pipeItemsRedstoneWood = registerPipe(pipeItemsRedstoneWoodId, PipeItemsRedstoneWood.class, "Redstone Wood Transport Pipe");
		pipeItemsDimTransfer = registerPipe(pipeItemsDimTransferId, PipeItemsDimTransfer.class, "Dimensional Transfer Transport Pipe");
		pipeLiquidsDimTransfer = registerPipe(pipeLiquidsDimTransferId, PipeLiquidsDimTransfer.class, "Dimensional Transfer Waterproof Pipe");
		pipePowerDimTransfer = registerPipe(pipePowerDimTransferId, PipePowerDimTransfer.class, "Dimensional Transfer Conductive Pipe");
		remoteConnector = new ItemRemoteConnector(remoteConnectorId).setItemName("remocon").setIconCoord(7, 0).setCreativeTab(CreativeTabs.tabTools);
		LanguageRegistry.addName(remoteConnector, "Remote Connector");
		Localization.addLocalization("/transferpipes/lang/", DefaultProps.DEFAULT_LANGUAGE);
		Object craftbase;
		if(balanceMode){
			craftbase = new ItemStack(BuildCraftSilicon.redstoneChipset, 1, 3);
		}
		else{
			craftbase = new ItemStack(Item.dyePowder, 1, 4);
		}
		GameRegistry.addShapelessRecipe(new ItemStack(pipeItemsTransfer, 1), new Object[]{craftbase , new ItemStack(BuildCraftTransport.pipeItemsGold)});
		GameRegistry.addShapelessRecipe(new ItemStack(pipeLiquidsTransfer, 1), new Object[]{pipeItemsTransfer, BuildCraftTransport.pipeWaterproof});
		GameRegistry.addShapelessRecipe(new ItemStack(pipePowerTransfer, 1), new Object[]{pipeItemsTransfer, Item.redstone});
		GameRegistry.addShapelessRecipe(new ItemStack(pipeItemsDimTransfer, 1), new Object[]{Item.eyeOfEnder, pipeItemsTransfer});
		GameRegistry.addShapelessRecipe(new ItemStack(pipeLiquidsDimTransfer, 1), new Object[]{Item.eyeOfEnder, pipeLiquidsTransfer});
		GameRegistry.addShapelessRecipe(new ItemStack(pipeLiquidsDimTransfer, 1), new Object[]{pipeItemsDimTransfer, BuildCraftTransport.pipeWaterproof});
		GameRegistry.addShapelessRecipe(new ItemStack(pipePowerDimTransfer, 1), new Object[]{pipeItemsDimTransfer, Item.redstone});
		GameRegistry.addShapelessRecipe(new ItemStack(pipePowerDimTransfer), new Object[]{Item.eyeOfEnder, pipePowerTransfer});
		GameRegistry.addRecipe(new ItemStack(pipeItemsRedstoneWood, 8), new Object[]{" E ", "RGR", 
																					Character.valueOf('E'), new ItemStack(BuildCraftEnergy.engineBlock, 1, 0), 
																					Character.valueOf('R'), Item.redstone, 
																					Character.valueOf('G'), Block.glass});
		GameRegistry.addRecipe(new ItemStack(remoteConnector, 1), new Object[]{"X X", " Y ", " X ", 
																				Character.valueOf('X'), craftbase, 
																				Character.valueOf('Y'), BuildCraftCore.wrenchItem});
		
	}
	
	public Item registerPipe(int id, Class<? extends Pipe> clas, String name){
		ItemPipe pipe = BlockGenericPipe.registerPipe(id, clas);
		pipe.setItemName(clas.getSimpleName());
		LanguageRegistry.addName(pipe, name);
		MinecraftForgeClient.registerItemRenderer(pipe.shiftedIndex, TransportProxyClient.pipeItemRenderer);
		return pipe;
	}

}